/*! vue-types - v1.3.3
 * https://github.com/dwightjack/vue-types
 * Copyright (c) 2018 - Marco Solazzi;
 * Licensed MIT
 */
!function(e,t){"object"==typeof exports&&"undefined"!=typeof module?module.exports=t(require("vue")):"function"==typeof define&&define.amd?define(["vue"],t):e.VueTypes=t(e.Vue)}(this,function(e){"use strict";e=e&&e.hasOwnProperty("default")?e.default:e;var t="undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{},n="object"==typeof t&&t&&t.Object===Object&&t,r="object"==typeof self&&self&&self.Object===Object&&self,o=(n||r||Function("return this")()).Symbol,u=Object.prototype,i=u.hasOwnProperty,a=u.toString,f=o?o.toStringTag:void 0;
/** Detect free variable `global` from Node.js. */var c=
/**
	 * A specialized version of `baseGetTag` which ignores `Symbol.toStringTag` values.
	 *
	 * @private
	 * @param {*} value The value to query.
	 * @returns {string} Returns the raw `toStringTag`.
	 */
function(e){var t=i.call(e,f),n=e[f];try{e[f]=void 0}catch(e){}var r=a.call(e);return t?e[f]=n:delete e[f],r},l=Object.prototype.toString;
/** Used for built-in method references. */var s=
/**
	 * Converts `value` to a string using `Object.prototype.toString`.
	 *
	 * @private
	 * @param {*} value The value to convert.
	 * @returns {string} Returns the converted string.
	 */
function(e){return l.call(e)},y=o?o.toStringTag:void 0;
/** `Object#toString` result references. */var p=
/**
	 * The base implementation of `getTag` without fallbacks for buggy environments.
	 *
	 * @private
	 * @param {*} value The value to query.
	 * @returns {string} Returns the `toStringTag`.
	 */
function(e){return null==e?void 0===e?"[object Undefined]":"[object Null]":y&&y in Object(e)?c(e):s(e)};
/**
	 * Creates a unary function that invokes `func` with its argument transformed.
	 *
	 * @private
	 * @param {Function} func The function to wrap.
	 * @param {Function} transform The argument transform.
	 * @returns {Function} Returns the new function.
	 */var d=function(t,n){return function(e){return t(n(e))}}(Object.getPrototypeOf,Object);
/** Built-in value references. */var v=
/**
	 * Checks if `value` is object-like. A value is object-like if it's not `null`
	 * and has a `typeof` result of "object".
	 *
	 * @static
	 * @memberOf _
	 * @since 4.0.0
	 * @category Lang
	 * @param {*} value The value to check.
	 * @returns {boolean} Returns `true` if `value` is object-like, else `false`.
	 * @example
	 *
	 * _.isObjectLike({});
	 * // => true
	 *
	 * _.isObjectLike([1, 2, 3]);
	 * // => true
	 *
	 * _.isObjectLike(_.noop);
	 * // => false
	 *
	 * _.isObjectLike(null);
	 * // => false
	 */
function(e){return null!=e&&"object"==typeof e},b=Function.prototype,m=Object.prototype,O=b.toString,j=m.hasOwnProperty,g=O.call(Object);
/** `Object#toString` result references. */var h=
/**
	 * Checks if `value` is a plain object, that is, an object created by the
	 * `Object` constructor or one with a `[[Prototype]]` of `null`.
	 *
	 * @static
	 * @memberOf _
	 * @since 0.8.0
	 * @category Lang
	 * @param {*} value The value to check.
	 * @returns {boolean} Returns `true` if `value` is a plain object, else `false`.
	 * @example
	 *
	 * function Foo() {
	 *   this.a = 1;
	 * }
	 *
	 * _.isPlainObject(new Foo);
	 * // => false
	 *
	 * _.isPlainObject([1, 2, 3]);
	 * // => false
	 *
	 * _.isPlainObject({ 'x': 0, 'y': 0 });
	 * // => true
	 *
	 * _.isPlainObject(Object.create(null));
	 * // => true
	 */
function(e){if(!v(e)||"[object Object]"!=p(e))return!1;var t=d(e);if(null===t)return!0;var n=j.call(t,"constructor")&&t.constructor;return"function"==typeof n&&n instanceof n&&O.call(n)==g},T=Object.prototype,_=T.toString,w=T.hasOwnProperty,P=/^\s*function (\w+)/,S=function(e){var t=null!=e?e.type?e.type:e:null,n=t&&t.toString().match(P);return n&&n[1]},x=function(){},A=Number.isInteger||function(e){return"number"==typeof e&&isFinite(e)&&Math.floor(e)===e},F=Array.isArray||function(e){return"[object Array]"===_.call(e)},q=function(e){return"[object Function]"===_.call(e)},N=function(e,t){var n,r;return Object.defineProperty(t,"_vueTypes_name",{enumerable:!1,writable:!1,value:e}),n=t,Object.defineProperty(n,"isRequired",{get:function(){return this.required=!0,this},enumerable:!1}),r=t,Object.defineProperty(r,"def",{value:function(e){return(void 0!==e||this.default)&&(q(e)||V(this,e)?F(e)?this.default=function(){return e.concat()}:h(e)?this.default=function(){return Object.assign({},e)}:this.default=e:k(this._vueTypes_name+' - invalid default value: "'+e+'"',e)),this},enumerable:!1,writable:!1}),q(t.validator)&&(t.validator=t.validator.bind(t)),t},V=function t(e,n,r){void 0===r&&(r=!1);var o,u=e,i=!0;h(e)||(u={type:e});var a,f=u._vueTypes_name?u._vueTypes_name+" - ":"";return w.call(u,"type")&&null!==u.type&&(F(u.type)?(i=u.type.some(function(e){return t(e,n,!0)}),o=u.type.map(function(e){return S(e)}).join(" or ")):i="Array"===(o=S(u))?F(n):"Object"===o?h(n):"String"===o||"Number"===o||"Boolean"===o||"Function"===o?function(e){if(null==e)return null;var t=e.constructor.toString().match(P);return t&&t[1]}(n)===o:n instanceof u.type),i?(w.call(u,"validator")&&q(u.validator)&&(r&&(a=k,k=x),i=u.validator(n),a&&(k=a),i||!1!==r||k(f+"custom validation failed")),i):(!1===r&&k(f+'value "'+n+'" should be of type "'+o+'"'),!1)},k=x,E={get any(){return N("any",{type:null})},get func(){return N("function",{type:Function}).def(Y.func)},get bool(){return N("boolean",{type:Boolean}).def(Y.bool)},get string(){return N("string",{type:String}).def(Y.string)},get number(){return N("number",{type:Number}).def(Y.number)},get array(){return N("array",{type:Array}).def(Y.array)},get object(){return N("object",{type:Object}).def(Y.object)},get integer(){return N("integer",{type:Number,validator:function(e){return A(e)}}).def(Y.integer)},get symbol(){return N("symbol",{type:null,validator:function(e){return"symbol"==typeof e}})},custom:function(n,r){if(void 0===r&&(r="custom validation failed"),"function"!=typeof n)throw new TypeError("[VueTypes error]: You must provide a function as argument");return N(n.name||"<<anonymous function>>",{validator:function(e){var t=n(e);return t||k(this._vueTypes_name+" - "+r),t}})},oneOf:function(n){if(!F(n))throw new TypeError("[VueTypes error]: You must provide an array as argument");var r='oneOf - value should be one of "'+n.join('", "')+'"',e=n.reduce(function(e,t){return null!=t&&-1===e.indexOf(t.constructor)&&e.push(t.constructor),e},[]);return N("oneOf",{type:0<e.length?e:null,validator:function(e){var t=-1!==n.indexOf(e);return t||k(r),t}})},instanceOf:function(e){return N("instanceOf",{type:e})},oneOfType:function(n){if(!F(n))throw new TypeError("[VueTypes error]: You must provide an array as argument");var r=!1,e=n.reduce(function(e,t,n){if(h(t)){if("oneOf"===t._vueTypes_name)return e.concat(t.type||[]);if(t.type&&!q(t.validator)){if(F(t.type))return e.concat(t.type);e.push(t.type)}else q(t.validator)&&(r=!0);return e}return e.push(t),e},[]);if(!r)
// we got just native objects (ie: Array, Object)
// delegate to Vue native prop check
return N("oneOfType",{type:e});var o=n.map(function(e){return e&&F(e.type)?e.type.map(S):S(e)}).reduce(function(e,t){return e.concat(F(t)?t:[t])},[]).join('", "');return this.custom(function(t){var e=n.some(function(e){return"oneOf"===e._vueTypes_name?!e.type||V(e.type,t,!0):V(e,t,!0)});return e||k('oneOfType - value type should be one of "'+o+'"'),e})},arrayOf:function(n){return N("arrayOf",{type:Array,validator:function(e){var t=e.every(function(e){return V(n,e)});return t||k('arrayOf - value must be an array of "'+S(n)+'"'),t}})},objectOf:function(n){return N("objectOf",{type:Object,validator:function(t){var e=Object.keys(t).every(function(e){return V(n,t[e])});return e||k('objectOf - value must be an object of "'+S(n)+'"'),e}})},shape:function(o){var u=Object.keys(o),e=u.filter(function(e){return o[e]&&!0===o[e].required}),t=N("shape",{type:Object,validator:function(n){var r=this;if(!h(n))return!1;var t=Object.keys(n);// check for required keys (if any)
return 0<e.length&&e.some(function(e){return-1===t.indexOf(e)})?(k('shape - at least one of required properties "'+e.join('", "')+'" is not present'),!1):t.every(function(e){if(-1===u.indexOf(e))return!0===r._vueTypes_isLoose||(k('shape - object is missing "'+e+'" property'),!1);var t=o[e];return V(t,n[e])})}});return Object.defineProperty(t,"_vueTypes_isLoose",{enumerable:!1,writable:!0,value:!1}),Object.defineProperty(t,"loose",{get:function(){return this._vueTypes_isLoose=!0,this},enumerable:!1}),t}},L=function(){return{func:x,bool:!0,string:"",number:0,array:function(){return[]},object:function(){return{}},integer:0}},Y=L();return Object.defineProperty(E,"sensibleDefaults",{enumerable:!1,set:function(e){!1===e?Y={}:!0===e?Y=L():h(e)&&(Y=e)},get:function(){return Y}}),E.utils={validate:function(e,t){return V(t,e,!0)},toType:N},E});
//# sourceMappingURL=vue-types.min.js.map
